/*
 * Class for conversion factor constants
 *
 */

package eetoolbelt;

/**
 *
 * @author ARLemaster
 */
public class ConversionFactors {

    /* Energy */
    public static final double HP_TO_WATT = 745.7;
    public static final double WATT_TO_HP = 1.0/HP_TO_WATT;

    /* Length */
    public static final double INCH_TO_MM = 25.4;

    /* Mass */
    public static final double OUNCE_TO_GRAM = 28.349523125;
    public static final double POUND_TO_GRAM = 453.5924;

    /* Pressure */
    public static final double ATM_TO_BAR = 1.01295;
    public static final double ATM_TO_DYNES = ATM_TO_BAR*1000000;
    public static final double ATM_TO_INHG = 29.9213;
    public static final double ATM_TO_INH2O = 406.86;
    public static final double ATM_TO_KGCM2 = 1.03325;
    public static final double ATM_TO_MBAR = ATM_TO_BAR*1000;
    public static final double ATM_TO_PA = ATM_TO_BAR*100000;
    public static final double ATM_TO_PSI = 14.696;
    public static final double ATM_TO_TORR = 760;
    public static final double ATM_TO_MTORR = ATM_TO_TORR*1000;

    public static final double BAR_TO_ATM = 0.9872;
    public static final double BAR_TO_DYNES = 1000000;
    public static final double BAR_TO_INHG = 29.54;
    public static final double BAR_TO_INH2O = 401.65;
    public static final double BAR_TO_KGCM2 = 1.02;
    public static final double BAR_TO_MBAR = 1000;
    public static final double BAR_TO_PA = 100000;
    public static final double BAR_TO_PSI = 14.503861;
    public static final double BAR_TO_TORR = 750.2838;
    public static final double BAR_TO_MTORR = ATM_TO_TORR*1000;

    public static final double DYNES_TO_ATM = 0.0000009872;
    public static final double DYNES_TO_BAR = 0.000001;
    public static final double DYNES_TO_INHG = 0.00002954;
    public static final double DYNES_TO_INH2O = 0.00040165;
    public static final double DYNES_TO_KGCM2 = 0.0000010200;
    public static final double DYNES_TO_MBAR = DYNES_TO_BAR*1000;
    public static final double DYNES_TO_PA = DYNES_TO_BAR*100000;
    public static final double DYNES_TO_PSI = 0.000014508;
    public static final double DYNES_TO_TORR = 0.00075028;
    public static final double DYNES_TO_MTORR = DYNES_TO_TORR*1000;

    public static final double INHG_TO_ATM = 0.03342;
    public static final double INHG_TO_BAR = 0.03385;
    public static final double INHG_TO_DYNES = INHG_TO_BAR*1000000;
    public static final double INHG_TO_INH2O = 13.598;
    public static final double INHG_TO_KGCM2 = 0.034532;
    public static final double INHG_TO_MBAR = INHG_TO_BAR*1000;
    public static final double INHG_TO_PA = INHG_TO_BAR*100000;
    public static final double INHG_TO_PSI = 0.4912;
    public static final double INHG_TO_TORR = 25.4;
    public static final double INHG_TO_MTORR = INHG_TO_TORR*1000;

    public static final double INH2O_TO_ATM = 0.002458;
    public static final double INH2O_TO_BAR = 0.002489;
    public static final double INH2O_TO_DYNES = INH2O_TO_BAR*1000000;
    public static final double INH2O_TO_INHG = 0.07354;
    public static final double INH2O_TO_KGCM2 = 0.0025396;
    public static final double INH2O_TO_MBAR = INH2O_TO_BAR*1000;
    public static final double INH2O_TO_PA = INH2O_TO_BAR*100000;
    public static final double INH2O_TO_PSI = 0.03612;
    public static final double INH2O_TO_TORR = 1.868;
    public static final double INH2O_TO_MTORR = INH2O_TO_TORR*1000;

    public static final double KGCM2_TO_ATM = 0.9678;
    public static final double KGCM2_TO_BAR = 0.9804;
    public static final double KGCM2_TO_DYNES = KGCM2_TO_BAR*1000000;
    public static final double KGCM2_TO_INHG = 28.958;
    public static final double KGCM2_TO_INH2O = 393.76;
    public static final double KGCM2_TO_MBAR = KGCM2_TO_BAR*1000;
    public static final double KGCM2_TO_PA = KGCM2_TO_BAR*100000;
    public static final double KGCM2_TO_PSI = 14.223;
    public static final double KGCM2_TO_TORR = 735.54;
    public static final double KGCM2_TO_MTORR = KGCM2_TO_TORR*1000;

    public static final double MBAR_TO_ATM = 0.0009872;
    public static final double MBAR_TO_BAR = 0.001;
    public static final double MBAR_TO_DYNES = 1000;
    public static final double MBAR_TO_INHG = 0.02954;
    public static final double MBAR_TO_INH2O = 0.4018;
    public static final double MBAR_TO_KGCM2 = 0.0010200;
    public static final double MBAR_TO_PA = 100;
    public static final double MBAR_TO_PSI = 0.01450;
    public static final double MBAR_TO_TORR = 0.75028;
    public static final double MBAR_TO_MTORR = MBAR_TO_TORR*1000;

    public static final double MTORR_TO_ATM = 0.0000013158;
    public static final double MTORR_TO_BAR = 0.0000013328;
    public static final double MTORR_TO_DYNES = MTORR_TO_BAR*1000000;
    public static final double MTORR_TO_INHG = 0.00003937;
    public static final double MTORR_TO_INH2O = 0.0005353;
    public static final double MTORR_TO_KGCM2 = 0.0000013595;
    public static final double MTORR_TO_MBAR = MTORR_TO_BAR*1000;
    public static final double MTORR_TO_PA = MTORR_TO_BAR*100000;
    public static final double MTORR_TO_PSI = 0.00001934;
    public static final double MTORR_TO_TORR = 0.001;

    public static final double PA_TO_ATM = 0.000009869;
    public static final double PA_TO_BAR = 0.00001;
    public static final double PA_TO_DYNES = PA_TO_BAR*1000000;
    public static final double PA_TO_INHG = 0.0002954;
    public static final double PA_TO_INH2O = 0.004018;
    public static final double PA_TO_KGCM2 = 0.00001020;
    public static final double PA_TO_MBAR = PA_TO_BAR*1000;
    public static final double PA_TO_PSI = 0.00014508;
    public static final double PA_TO_TORR = 0.0075028;
    public static final double PA_TO_MTORR= PA_TO_TORR*1000;

    public static final double PSI_TO_ATM = 0.068046;
    public static final double PSI_TO_BAR = 0.068948;
    public static final double PSI_TO_DYNES = PSI_TO_BAR*1000000;
    public static final double PSI_TO_INHG = 2.036;
    public static final double PSI_TO_INH2O = 27.68;
    public static final double PSI_TO_KGCM2 = 0.070309;
    public static final double PSI_TO_MBAR = PSI_TO_BAR*1000;
    public static final double PSI_TO_PA = 6892.7;
    public static final double PSI_TO_TORR = 51.71;
    public static final double PSI_TO_MTORR= PSI_TO_TORR*1000;

    public static final double TORR_TO_ATM = MTORR_TO_ATM*1000;
    public static final double TORR_TO_BAR = MTORR_TO_BAR*1000;
    public static final double TORR_TO_DYNES = MTORR_TO_DYNES*1000;
    public static final double TORR_TO_INHG = MTORR_TO_INHG*1000;
    public static final double TORR_TO_INH2O = MTORR_TO_INH2O*1000;
    public static final double TORR_TO_KGCM2 = MTORR_TO_KGCM2*1000;
    public static final double TORR_TO_MBAR = MTORR_TO_MBAR*1000;
    public static final double TORR_TO_PA = MTORR_TO_PA*1000;
    public static final double TORR_TO_PSI = MTORR_TO_PSI*1000;
    public static final double TORR_TO_MTORR = 1000;

}
