/*
 * Derived class of Conversions
 *
 */

package eetoolbelt;

import static eetoolbelt.ConversionFactors.*;

/**
 *
 * @author Anthony Lemaster
 */
public class Pressure extends Conversions {

    /* Attributes */
    private String[] pressureDataList = {"atm","bar","dynes/cm2 or microbar","in Hg","in H2O","kg/cm2","millibar","millitorr or um Hg","Pa or N/m2","PSI", "Torr or mm Hg"};
    private double dblInput;
    private double dblOutput;

    /* Class Constructor */
    public Pressure() {
        super("Pressure Conversions");
    }

    /* Methods */
    @Override
    public String[] GetDataList() {
        return pressureDataList;
    }
    @Override
    public String Convert()
    {
        dblInput = Double.valueOf(input);

        /* To atmosphere */
        if (toIndex == 0 && fromIndex == 0)
        {
            dblOutput = atm2atm();
        }
        else if (toIndex == 0 && fromIndex == 1)
        {
            dblOutput = bar2atm();
        }
        else if (toIndex == 0 && fromIndex == 2)
        {
            dblOutput = dyn2atm();
        }
        else if (toIndex == 0 && fromIndex == 3)
        {
            dblOutput = inHg2atm();
        }
        else if (toIndex == 0 && fromIndex == 4)
        {
            dblOutput = inH2O2atm();
        }
        else if (toIndex == 0 && fromIndex == 5)
        {
            dblOutput = kgcm2atm();
        }
        else if (toIndex == 0 && fromIndex == 6)
        {
            dblOutput = mbar2atm();
        }
        else if (toIndex == 0 && fromIndex == 7)
        {
            dblOutput = mtorr2atm();
        }
        else if (toIndex == 0 && fromIndex == 8)
        {
            dblOutput = Pa2atm();
        }
        else if (toIndex == 0 && fromIndex == 9)
        {
            dblOutput = psi2atm();
        }
        else if (toIndex == 0 && fromIndex == 10)
        {
            dblOutput = torr2atm();
        }

        /* To bar */
        else if (toIndex == 1 && fromIndex == 0)
        {
            dblOutput = atm2bar();
        }
        else if (toIndex == 1 && fromIndex == 1)
        {
            dblOutput = bar2bar();
        }
        else if (toIndex == 1 && fromIndex == 2)
        {
            dblOutput = dyn2bar();
        }
        else if (toIndex == 1 && fromIndex == 3)
        {
            dblOutput = inHg2bar();
        }
        else if (toIndex == 1 && fromIndex == 4)
        {
            dblOutput = inH2O2bar();
        }
        else if (toIndex == 1 && fromIndex == 5)
        {
            dblOutput = kgcm2bar();
        }
        else if (toIndex == 1 && fromIndex == 6)
        {
            dblOutput = mbar2bar();
        }
        else if (toIndex == 1 && fromIndex == 7)
        {
            dblOutput = mtorr2bar();
        }
        else if (toIndex == 1 && fromIndex == 8)
        {
            dblOutput = Pa2bar();
        }
        else if (toIndex == 1 && fromIndex == 9)
        {
            dblOutput = psi2bar();
        }
        else if (toIndex == 1 && fromIndex == 10)
        {
            dblOutput = torr2bar();
        }

        /* To dynes/cm2 */
        else if (toIndex == 2 && fromIndex == 0)
        {
            dblOutput = atm2dyn();
        }
        else if (toIndex == 2 && fromIndex == 1)
        {
            dblOutput = bar2dyn();
        }
        else if (toIndex == 2 && fromIndex == 2)
        {
            dblOutput = dyn2dyn();
        }
        else if (toIndex == 2 && fromIndex == 3)
        {
            dblOutput = inHg2dyn();
        }
        else if (toIndex == 2 && fromIndex == 4)
        {
            dblOutput = inH2O2dyn();
        }
        else if (toIndex == 2 && fromIndex == 5)
        {
            dblOutput = kgcm2dyn();
        }
        else if (toIndex == 2 && fromIndex == 6)
        {
            dblOutput = mbar2dyn();
        }
        else if (toIndex == 2 && fromIndex == 7)
        {
            dblOutput = mtorr2dyn();
        }
        else if (toIndex == 2 && fromIndex == 8)
        {
            dblOutput = Pa2dyn();
        }
        else if (toIndex == 2 && fromIndex == 9)
        {
            dblOutput = psi2dyn();
        }
        else if (toIndex == 2 && fromIndex == 10)
        {
            dblOutput = torr2dyn();
        }

        /* To inHg */
        else if (toIndex == 3 && fromIndex == 0)
        {
            dblOutput = atm2inHg();
        }
        else if (toIndex == 3 && fromIndex == 1)
        {
            dblOutput = bar2inHg();
        }
        else if (toIndex == 3 && fromIndex == 2)
        {
            dblOutput = dyn2inHg();
        }
        else if (toIndex == 3 && fromIndex == 3)
        {
            dblOutput = inHg2inHg();
        }
        else if (toIndex == 3 && fromIndex == 4)
        {
            dblOutput = inH2O2inHg();
        }
        else if (toIndex == 3 && fromIndex == 5)
        {
            dblOutput = kgcm2inHg();
        }
        else if (toIndex == 3 && fromIndex == 6)
        {
            dblOutput = mbar2inHg();
        }
        else if (toIndex == 3 && fromIndex == 7)
        {
            dblOutput = mtorr2inHg();
        }
        else if (toIndex == 3 && fromIndex == 8)
        {
            dblOutput = Pa2inHg();
        }
        else if (toIndex == 3 && fromIndex == 9)
        {
            dblOutput = psi2inHg();
        }
        else if (toIndex == 3 && fromIndex == 10)
        {
            dblOutput = torr2inHg();
        }

        /* To inH2O */
        else if (toIndex == 4 && fromIndex == 0)
        {
            dblOutput = atm2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 1)
        {
            dblOutput = bar2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 2)
        {
            dblOutput = dyn2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 3)
        {
            dblOutput = inHg2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 4)
        {
            dblOutput = inH2O2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 5)
        {
            dblOutput = kgcm2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 6)
        {
            dblOutput = mbar2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 7)
        {
            dblOutput = mtorr2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 8)
        {
            dblOutput = Pa2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 9)
        {
            dblOutput = psi2inH2O();
        }
        else if (toIndex == 4 && fromIndex == 10)
        {
            dblOutput = torr2inH2O();
        }

        /* To kg/cm2 */
        else if (toIndex == 5 && fromIndex == 0)
        {
            dblOutput = atm2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 1)
        {
            dblOutput = bar2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 2)
        {
            dblOutput = dyn2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 3)
        {
            dblOutput = inHg2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 4)
        {
            dblOutput = inH2O2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 5)
        {
            dblOutput = kgcm2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 6)
        {
            dblOutput = mbar2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 7)
        {
            dblOutput = mtorr2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 8)
        {
            dblOutput = Pa2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 9)
        {
            dblOutput = psi2kgcm();
        }
        else if (toIndex == 5 && fromIndex == 10)
        {
            dblOutput = torr2kgcm();
        }

        /* To mbar */
        else if (toIndex == 6 && fromIndex == 0)
        {
            dblOutput = atm2mbar();
        }
        else if (toIndex == 6 && fromIndex == 1)
        {
            dblOutput = bar2mbar();
        }
        else if (toIndex == 6 && fromIndex == 2)
        {
            dblOutput = dyn2mbar();
        }
        else if (toIndex == 6 && fromIndex == 3)
        {
            dblOutput = inHg2mbar();
        }
        else if (toIndex == 6 && fromIndex == 4)
        {
            dblOutput = inH2O2mbar();
        }
        else if (toIndex == 6 && fromIndex == 5)
        {
            dblOutput = kgcm2mbar();
        }
        else if (toIndex == 6 && fromIndex == 6)
        {
            dblOutput = mbar2mbar();
        }
        else if (toIndex == 6 && fromIndex == 7)
        {
            dblOutput = mtorr2mbar();
        }
        else if (toIndex == 6 && fromIndex == 8)
        {
            dblOutput = Pa2mbar();
        }
        else if (toIndex == 6 && fromIndex == 9)
        {
            dblOutput = psi2mbar();
        }
        else if (toIndex == 6 && fromIndex == 10)
        {
            dblOutput = torr2mbar();
        }

        /* To mtorr */
        else if (toIndex == 7 && fromIndex == 0)
        {
            dblOutput = atm2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 1)
        {
            dblOutput = bar2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 2)
        {
            dblOutput = dyn2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 3)
        {
            dblOutput = inHg2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 4)
        {
            dblOutput = inH2O2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 5)
        {
            dblOutput = kgcm2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 6)
        {
            dblOutput = mbar2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 7)
        {
            dblOutput = mtorr2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 8)
        {
            dblOutput = Pa2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 9)
        {
            dblOutput = psi2mtorr();
        }
        else if (toIndex == 7 && fromIndex == 10)
        {
            dblOutput = torr2mtorr();
        }

        /* To Pascal */
        else if (toIndex == 8 && fromIndex == 0)
        {
            dblOutput = atm2Pa();
        }
        else if (toIndex == 8 && fromIndex == 1)
        {
            dblOutput = bar2Pa();
        }
        else if (toIndex == 8 && fromIndex == 2)
        {
            dblOutput = dyn2Pa();
        }
        else if (toIndex == 8 && fromIndex == 3)
        {
            dblOutput = inHg2Pa();
        }
        else if (toIndex == 8 && fromIndex == 4)
        {
            dblOutput = inH2O2Pa();
        }
        else if (toIndex == 8 && fromIndex == 5)
        {
            dblOutput = kgcm2Pa();
        }
        else if (toIndex == 8 && fromIndex == 6)
        {
            dblOutput = mbar2Pa();
        }
        else if (toIndex == 8 && fromIndex == 7)
        {
            dblOutput = mtorr2Pa();
        }
        else if (toIndex == 8 && fromIndex == 8)
        {
            dblOutput = Pa2Pa();
        }
        else if (toIndex == 8 && fromIndex == 9)
        {
            dblOutput = psi2Pa();
        }
        else if (toIndex == 8 && fromIndex == 10)
        {
            dblOutput = torr2Pa();
        }

        /* To PSI */
        else if (toIndex == 9 && fromIndex == 0)
        {
            dblOutput = atm2psi();
        }
        else if (toIndex == 9 && fromIndex == 1)
        {
            dblOutput = bar2psi();
        }
        else if (toIndex == 9 && fromIndex == 2)
        {
            dblOutput = dyn2psi();
        }
        else if (toIndex == 9 && fromIndex == 3)
        {
            dblOutput = inHg2psi();
        }
        else if (toIndex == 9 && fromIndex == 4)
        {
            dblOutput = inH2O2psi();
        }
        else if (toIndex == 9 && fromIndex == 5)
        {
            dblOutput = kgcm2psi();
        }
        else if (toIndex == 9 && fromIndex == 6)
        {
            dblOutput = mbar2psi();
        }
        else if (toIndex == 9 && fromIndex == 7)
        {
            dblOutput = mtorr2psi();
        }
        else if (toIndex == 9 && fromIndex == 8)
        {
            dblOutput = Pa2psi();
        }
        else if (toIndex == 9 && fromIndex == 9)
        {
            dblOutput = psi2psi();
        }
        else if (toIndex == 9 && fromIndex == 10)
        {
            dblOutput = torr2psi();
        }

        /* To Torr */
        else if (toIndex == 10 && fromIndex == 0)
        {
            dblOutput = atm2torr();
        }
        else if (toIndex == 10 && fromIndex == 1)
        {
            dblOutput = bar2torr();
        }
        else if (toIndex == 10 && fromIndex == 2)
        {
            dblOutput = dyn2torr();
        }
        else if (toIndex == 10 && fromIndex == 3)
        {
            dblOutput = inHg2torr();
        }
        else if (toIndex == 10 && fromIndex == 4)
        {
            dblOutput = inH2O2torr();
        }
        else if (toIndex == 10 && fromIndex == 5)
        {
            dblOutput = kgcm2torr();
        }
        else if (toIndex == 10 && fromIndex == 6)
        {
            dblOutput = mbar2torr();
        }
        else if (toIndex == 10 && fromIndex == 7)
        {
            dblOutput = mtorr2torr();
        }
        else if (toIndex == 10 && fromIndex == 8)
        {
            dblOutput = Pa2torr();
        }
        else if (toIndex == 10 && fromIndex == 9)
        {
            dblOutput = psi2torr();
        }
        else if (toIndex == 10 && fromIndex == 10)
        {
            dblOutput = torr2torr();
        }
        
        output = String.format("%." + precision + "f", dblOutput); //Formatted for 3 after decimal point
        return output;
    }
    /* To atmosphere Methods */
    double atm2atm () {
        return dblInput;
    }
    double bar2atm () {
        return dblInput * BAR_TO_ATM;
    }
    double dyn2atm () {
        return dblInput * DYNES_TO_ATM;
    }
    double inHg2atm () {
        return dblInput * INHG_TO_ATM;
    }
    double inH2O2atm () {
        return dblInput * INH2O_TO_ATM;
    }
    double kgcm2atm () {
        return dblInput * KGCM2_TO_ATM;
    }
    double mbar2atm () {
        return dblInput * MBAR_TO_ATM;
    }
    double mtorr2atm () {
        return dblInput * MTORR_TO_ATM;
    }
    double Pa2atm () {
        return dblInput * PA_TO_ATM;
    }
    double psi2atm () {
        return dblInput * PSI_TO_ATM;
    }
    double torr2atm () {
        return dblInput * TORR_TO_ATM;
    }

    /* To bar Methods */
    double atm2bar () {
        return dblInput * ATM_TO_BAR;
    }
    double bar2bar () {
        return dblInput;
    }
    double dyn2bar () {
        return dblInput * DYNES_TO_BAR;
    }
    double inHg2bar () {
        return dblInput * INHG_TO_BAR;
    }
    double inH2O2bar () {
        return dblInput * INH2O_TO_BAR;
    }
    double kgcm2bar () {
        return dblInput * KGCM2_TO_BAR;
    }
    double mbar2bar () {
        return dblInput * MBAR_TO_BAR;
    }
    double mtorr2bar () {
        return dblInput * MTORR_TO_BAR;
    }
    double Pa2bar () {
        return dblInput * PA_TO_BAR;
    }
    double psi2bar () {
        return dblInput * PSI_TO_BAR;
    }
    double torr2bar () {
        return dblInput * TORR_TO_BAR;
    }

    /* To dynes/cm2 Methods */
    double atm2dyn () {
        return dblInput * ATM_TO_DYNES;
    }
    double bar2dyn () {
        return dblInput * BAR_TO_DYNES;
    }
    double dyn2dyn () {
        return dblInput;
    }
    double inHg2dyn () {
        return dblInput * INHG_TO_DYNES;
    }
    double inH2O2dyn () {
        return dblInput * INH2O_TO_DYNES;
    }
    double kgcm2dyn () {
        return dblInput * KGCM2_TO_DYNES;
    }
    double mbar2dyn () {
        return dblInput * MBAR_TO_DYNES;
    }
    double mtorr2dyn () {
        return dblInput * MTORR_TO_DYNES;
    }
    double Pa2dyn () {
        return dblInput * PA_TO_DYNES;
    }
    double psi2dyn () {
        return dblInput * PSI_TO_DYNES;
    }
    double torr2dyn () {
        return dblInput * TORR_TO_DYNES;
    }

     /* To inHg Methods */
    double atm2inHg () {
        return dblInput * ATM_TO_INHG;
    }
    double bar2inHg () {
        return dblInput * BAR_TO_INHG;
    }
    double dyn2inHg () {
        return dblInput * DYNES_TO_INHG;
    }
    double inHg2inHg () {
        return dblInput;
    }
    double inH2O2inHg () {
        return dblInput * INH2O_TO_INHG;
    }
    double kgcm2inHg () {
        return dblInput * KGCM2_TO_INHG;
    }
    double mbar2inHg () {
        return dblInput * MBAR_TO_INHG;
    }
    double mtorr2inHg () {
        return dblInput * MTORR_TO_INHG;
    }
    double Pa2inHg () {
        return dblInput * PA_TO_INHG;
    }
    double psi2inHg () {
        return dblInput * PSI_TO_INHG;
    }
    double torr2inHg () {
        return dblInput * TORR_TO_INHG;
    }

    /* To inH2O Methods */
    double atm2inH2O () {
        return dblInput * ATM_TO_INH2O;
    }
    double bar2inH2O () {
        return dblInput * BAR_TO_INH2O;
    }
    double dyn2inH2O () {
        return dblInput * DYNES_TO_INH2O;
    }
    double inHg2inH2O () {
        return dblInput * INHG_TO_INH2O;
    }
    double inH2O2inH2O () {
        return dblInput;
    }
    double kgcm2inH2O () {
        return dblInput * KGCM2_TO_INH2O;
    }
    double mbar2inH2O () {
        return dblInput * MBAR_TO_INH2O;
    }
    double mtorr2inH2O () {
        return dblInput * MTORR_TO_INH2O;
    }
    double Pa2inH2O () {
        return dblInput * PA_TO_INH2O;
    }
    double psi2inH2O () {
        return dblInput * PSI_TO_INH2O;
    }
    double torr2inH2O () {
        return dblInput * TORR_TO_INH2O;
    }

    /* To kg/cm2 Methods */
    double atm2kgcm () {
        return dblInput * ATM_TO_KGCM2;
    }
    double bar2kgcm () {
        return dblInput * BAR_TO_KGCM2;
    }
    double dyn2kgcm () {
        return dblInput * DYNES_TO_KGCM2;
    }
    double inHg2kgcm () {
        return dblInput * INHG_TO_KGCM2;
    }
    double inH2O2kgcm () {
        return dblInput * INH2O_TO_KGCM2;
    }
    double kgcm2kgcm () {
        return dblInput;
    }
    double mbar2kgcm () {
        return dblInput * MBAR_TO_KGCM2;
    }
    double mtorr2kgcm () {
        return dblInput * MTORR_TO_KGCM2;
    }
    double Pa2kgcm () {
        return dblInput * PA_TO_KGCM2;
    }
    double psi2kgcm () {
        return dblInput * PSI_TO_KGCM2;
    }
    double torr2kgcm () {
        return dblInput * TORR_TO_KGCM2;
    }

    /* To mbar Methods */
    double atm2mbar () {
        return dblInput * ATM_TO_MBAR;
    }
    double bar2mbar () {
        return dblInput * BAR_TO_MBAR;
    }
    double dyn2mbar () {
        return dblInput * DYNES_TO_MBAR;
    }
    double inHg2mbar () {
        return dblInput * INHG_TO_MBAR;
    }
    double inH2O2mbar () {
        return dblInput * INH2O_TO_MBAR;
    }
    double kgcm2mbar () {
        return dblInput * KGCM2_TO_MBAR;
    }
    double mbar2mbar () {
        return dblInput;
    }
    double mtorr2mbar () {
        return dblInput * MTORR_TO_MBAR;
    }
    double Pa2mbar () {
        return dblInput * PA_TO_MBAR;
    }
    double psi2mbar () {
        return dblInput * PSI_TO_MBAR;
    }
    double torr2mbar () {
        return dblInput * TORR_TO_MBAR;
    }

    /* To mtorr Methods */
    double atm2mtorr () {
        return dblInput * ATM_TO_MTORR;
    }
    double bar2mtorr () {
        return dblInput * BAR_TO_MTORR;
    }
    double dyn2mtorr () {
        return dblInput * DYNES_TO_MTORR;
    }
    double inHg2mtorr () {
        return dblInput * INHG_TO_MTORR;
    }
    double inH2O2mtorr () {
        return dblInput * INH2O_TO_MTORR;
    }
    double kgcm2mtorr () {
        return dblInput * KGCM2_TO_MTORR;
    }
    double mbar2mtorr () {
        return dblInput * MBAR_TO_MTORR;
    }
    double mtorr2mtorr () {
        return dblInput;
    }
    double Pa2mtorr () {
        return dblInput * PA_TO_MTORR;
    }
    double psi2mtorr () {
        return dblInput * PSI_TO_MTORR;
    }
    double torr2mtorr () {
        return dblInput * TORR_TO_MTORR;
    }

    /* To Pascal Methods */
    double atm2Pa () {
        return dblInput * ATM_TO_PA;
    }
    double bar2Pa () {
        return dblInput * BAR_TO_PA;
    }
    double dyn2Pa () {
        return dblInput * DYNES_TO_PA;
    }
    double inHg2Pa () {
        return dblInput * INHG_TO_PA;
    }
    double inH2O2Pa () {
        return dblInput * INH2O_TO_PA;
    }
    double kgcm2Pa () {
        return dblInput * KGCM2_TO_PA;
    }
    double mbar2Pa () {
        return dblInput * MBAR_TO_PA;
    }
    double mtorr2Pa () {
        return dblInput * MTORR_TO_PA;
    }
    double Pa2Pa () {
        return dblInput;
    }
    double psi2Pa () {
        return dblInput * PSI_TO_PA;
    }
    double torr2Pa () {
        return dblInput * TORR_TO_PA;
    }

    /* To PSI Methods */
    double atm2psi () {
        return dblInput * ATM_TO_PSI;
    }
    double bar2psi () {
        return dblInput * BAR_TO_PSI;
    }
    double dyn2psi () {
        return dblInput * DYNES_TO_PSI;
    }
    double inHg2psi () {
        return dblInput * INHG_TO_PSI;
    }
    double inH2O2psi () {
        return dblInput * INH2O_TO_PSI;
    }
    double kgcm2psi () {
        return dblInput * KGCM2_TO_PSI;
    }
    double mbar2psi () {
        return dblInput * MBAR_TO_PSI;
    }
    double mtorr2psi () {
        return dblInput * MTORR_TO_PSI;
    }
    double Pa2psi () {
        return dblInput * PA_TO_PSI;
    }
    double psi2psi () {
        return dblInput;
    }
    double torr2psi () {
        return dblInput * TORR_TO_PSI;
    }

    /* To Torr Methods */
    double atm2torr () {
        return dblInput * ATM_TO_TORR;
    }
    double bar2torr () {
        return dblInput * BAR_TO_TORR;
    }
    double dyn2torr () {
        return dblInput * DYNES_TO_TORR;
    }
    double inHg2torr () {
        return dblInput * INHG_TO_TORR;
    }
    double inH2O2torr () {
        return dblInput * INH2O_TO_TORR;
    }
    double kgcm2torr () {
        return dblInput * KGCM2_TO_TORR;
    }
    double mbar2torr () {
        return dblInput * MBAR_TO_TORR;
    }
    double mtorr2torr () {
        return dblInput * MTORR_TO_TORR;
    }
    double Pa2torr () {
        return dblInput * PA_TO_TORR;
    }
    double psi2torr () {
        return dblInput * PSI_TO_TORR;
    }
    double torr2torr () {
        return dblInput;
    }
}
