/*
 * frmEEToolbeltDashboard.java
 */

package eetoolbelt;

/**
 *
 * @author Anthony Lemaster
 */

import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;


/**
 * The application's main frame.
 */
public class frmEEToolbeltDashboard extends FrameView {

    public frmEEToolbeltDashboard(SingleFrameApplication app) {
        super(app);

        initComponents();

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    
                }
            }
        });
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = EEToolbeltApp.getApplication().getMainFrame();
            aboutBox = new frmEEToolbeltAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        EEToolbeltApp.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        mnuCalculators = new javax.swing.JMenu();
        mnuCalcSignalScale = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        mnuConvPressure = new javax.swing.JMenuItem();
        mnuConvRadix = new javax.swing.JMenuItem();
        mnuConvTemperature = new javax.swing.JMenuItem();
        mnuApps = new javax.swing.JMenu();
        mnuAppsStickyNotes = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();

        mainPanel.setName("mainPanel"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(eetoolbelt.EEToolbeltApp.class).getContext().getResourceMap(frmEEToolbeltDashboard.class);
        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jLabel2.setIcon(resourceMap.getIcon("jLabel2.icon")); // NOI18N
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 370, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 370, Short.MAX_VALUE))
                .addGap(100, 100, 100))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(34, Short.MAX_VALUE))
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(eetoolbelt.EEToolbeltApp.class).getContext().getActionMap(frmEEToolbeltDashboard.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        mnuCalculators.setAction(actionMap.get("showFrmBaseConv")); // NOI18N
        mnuCalculators.setText(resourceMap.getString("mnuCalculators.text")); // NOI18N
        mnuCalculators.setName("mnuCalculators"); // NOI18N

        mnuCalcSignalScale.setAction(actionMap.get("showFrmSignalScale")); // NOI18N
        mnuCalcSignalScale.setText(resourceMap.getString("mnuCalcSignalScale.text")); // NOI18N
        mnuCalcSignalScale.setActionCommand(resourceMap.getString("mnuCalcSignalScale.actionCommand")); // NOI18N
        mnuCalcSignalScale.setName("mnuCalcSignalScale"); // NOI18N
        mnuCalculators.add(mnuCalcSignalScale);

        menuBar.add(mnuCalculators);

        jMenu1.setAction(actionMap.get("showFrmConvRadix")); // NOI18N
        jMenu1.setText(resourceMap.getString("jMenu1.text")); // NOI18N
        jMenu1.setName("jMenu1"); // NOI18N

        mnuConvPressure.setAction(actionMap.get("showFrmConvPressure")); // NOI18N
        mnuConvPressure.setText(resourceMap.getString("mnuConvPressure.text")); // NOI18N
        mnuConvPressure.setToolTipText(resourceMap.getString("mnuConvPressure.toolTipText")); // NOI18N
        mnuConvPressure.setName("mnuConvPressure"); // NOI18N
        jMenu1.add(mnuConvPressure);

        mnuConvRadix.setAction(actionMap.get("showFrmConvRadix")); // NOI18N
        mnuConvRadix.setText(resourceMap.getString("mnuConvRadix.text")); // NOI18N
        mnuConvRadix.setToolTipText(resourceMap.getString("mnuConvRadix.toolTipText")); // NOI18N
        mnuConvRadix.setName("mnuConvRadix"); // NOI18N
        jMenu1.add(mnuConvRadix);

        mnuConvTemperature.setAction(actionMap.get("showFrmConvTemperature")); // NOI18N
        mnuConvTemperature.setText(resourceMap.getString("mnuConvTemperature.text")); // NOI18N
        mnuConvTemperature.setToolTipText(resourceMap.getString("mnuConvTemperature.toolTipText")); // NOI18N
        mnuConvTemperature.setName("mnuConvTemperature"); // NOI18N
        jMenu1.add(mnuConvTemperature);

        menuBar.add(jMenu1);

        mnuApps.setText(resourceMap.getString("mnuApps.text")); // NOI18N
        mnuApps.setName("mnuApps"); // NOI18N

        mnuAppsStickyNotes.setAction(actionMap.get("showFrmStickyNote")); // NOI18N
        mnuAppsStickyNotes.setText(resourceMap.getString("mnuAppsStickyNotes.text")); // NOI18N
        mnuAppsStickyNotes.setName("mnuAppsStickyNotes"); // NOI18N
        mnuApps.add(mnuAppsStickyNotes);

        menuBar.add(mnuApps);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setComponent(mainPanel);
        setMenuBar(menuBar);
    }// </editor-fold>//GEN-END:initComponents

        @Action
    public void showFrmSignalScale() {
        if (newFrmSignalScale == null) {
            JFrame mainFrame = EEToolbeltApp.getApplication().getMainFrame();
            newFrmSignalScale = new frmSignalScale();
            newFrmSignalScale.setLocationRelativeTo(mainFrame);
        }
        EEToolbeltApp.getApplication().show(newFrmSignalScale);
    }

            @Action
    public void showFrmConvPressure() {
        if (frmConvPressure == null) {
            JFrame mainFrame = EEToolbeltApp.getApplication().getMainFrame();
            frmConvPressure = new frmConversions(newConversions[0]);
            frmConvPressure.setLocationRelativeTo(mainFrame);

        }
        EEToolbeltApp.getApplication().show(frmConvPressure);
    }

       @Action
    public void showFrmConvRadix() {
        if (frmConvRadix == null) {
            JFrame mainFrame = EEToolbeltApp.getApplication().getMainFrame();
            frmConvRadix = new frmConversions(newConversions[1]);
            frmConvRadix.setLocationRelativeTo(mainFrame);

        }
        EEToolbeltApp.getApplication().show(frmConvRadix);
    }

       @Action
    public void showFrmConvTemperature() {
        if (frmConvTemperature == null) {
            JFrame mainFrame = EEToolbeltApp.getApplication().getMainFrame();
            frmConvTemperature = new frmConversions(newConversions[2]);
            frmConvTemperature.setLocationRelativeTo(mainFrame);

        }
        EEToolbeltApp.getApplication().show(frmConvTemperature);
    }

       @Action
    public void showFrmStickyNote() {
        if (newFrmStickyNote[frmInstance] == null && frmInstance < 10) {
            JFrame mainFrame = EEToolbeltApp.getApplication().getMainFrame();
            newFrmStickyNote[frmInstance] = new frmStickyNote();
            newFrmStickyNote[frmInstance].setLocationRelativeTo(mainFrame);
            frmInstance++;
        }
        EEToolbeltApp.getApplication().show(newFrmStickyNote[frmInstance-1]);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenu mnuApps;
    private javax.swing.JMenuItem mnuAppsStickyNotes;
    private javax.swing.JMenuItem mnuCalcSignalScale;
    private javax.swing.JMenu mnuCalculators;
    private javax.swing.JMenuItem mnuConvPressure;
    private javax.swing.JMenuItem mnuConvRadix;
    private javax.swing.JMenuItem mnuConvTemperature;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;
    private JFrame newFrmSignalScale;
    private JFrame frmConvPressure;
    private JFrame frmConvRadix;
    private JFrame frmConvTemperature;
    private JFrame[] newFrmStickyNote = new JFrame[10];
    private int frmInstance = 0;

    public Conversions[] newConversions = {
                                            new Pressure(),
                                            new Radix(),
                                            new Temperature()
                                            };
}
